/*
 * gMusic Score Editor
 *
 * Copyright (C) 1995-2001 Allan R. Black
 *
 * include/choice.h
 *
 */

#define GTK_TYPE_CHOICE		(gtk_choice_get_type())
#define GTK_CHOICE(obj)		(GTK_CHECK_CAST((obj), GTK_TYPE_CHOICE, GtkChoice))
#define GTK_IS_CHOICE(obj)	(GTK_CHECK_TYPE((obj), GTK_TYPE_CHOICE))

typedef struct _GtkChoice	GtkChoice;
typedef struct _GtkChoiceClass	GtkChoiceClass;

struct _GtkChoice {
	GtkButton	button;
	GtkWidget	*label;
	GtkWidget	*arrow;
	GtkWidget	*popup;
	GtkWidget	*menu;
	GtkWidget	*list;

	guint		enter_id;

	guint		nitems;
	guint		selection;

	guint		has_selection	: 1;
	guint		active		: 1;
	guint		dragging	: 1;
	guint		in_button	: 1;
	guint		in_menu		: 1;
	guint		in_list		: 1;
};

struct _GtkChoiceClass {
	GtkButtonClass	parent_class;

	void		(*choice_select)	(GtkChoice *, guint);
};

GtkWidget	*gtk_choice_new(void);
void		gtk_choice_menu_clear(GtkChoice *);
void		gtk_choice_menu_add(GtkChoice *, gchar *);
void		gtk_choice_menu_set(GtkChoice *, GList *);
void		gtk_choice_menu_select(GtkChoice *, guint);
void		gtk_choice_menu_unselect(GtkChoice *);

