/*
 * Test for choice widget
 */

#include <gtk/gtk.h>
#include <gtkchoice.h>

GtkWidget *spinbutton; /* HACK */

static void cb_select(GtkWidget *w, guint n, GtkAdjustment *adj)
{
	gint cval;

	cval = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinbutton));
	if(n != cval) {
		adj->value = n;
		gtk_adjustment_value_changed(adj);
	}
}

static void cb_sensitive(GtkWidget *w, GtkWidget *choice)
{
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(w)))
		gtk_widget_set_sensitive(choice, TRUE);
}

static void cb_insensitive(GtkWidget *w, GtkWidget *choice)
{
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(w)))
		gtk_widget_set_sensitive(choice, FALSE);
}

static void cb_unselect(GtkWidget *w, GtkChoice *choice)
{
	gtk_choice_menu_unselect(choice);
}

static void cb_spinvalue(GtkWidget *w, GtkChoice *choice)
{
	gint n;

	n = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinbutton));
	gtk_choice_menu_select(choice, n);
}

main(int argc, char **argv)
{
	GtkWidget *top, *vbox, *hbox, *choice, *w;
	GtkAdjustment *adj;
	GSList *rg;

	gtk_init(&argc, &argv);
	top = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	vbox = gtk_vbox_new(FALSE, 5);
	gtk_container_add(GTK_CONTAINER(top), vbox);

	hbox = gtk_hbox_new(FALSE, 0);
	choice = gtk_choice_new();
	gtk_choice_menu_add(GTK_CHOICE(choice), "First object");
	gtk_choice_menu_add(GTK_CHOICE(choice), "Second object");
	gtk_choice_menu_add(GTK_CHOICE(choice), "Duplicate name");
	gtk_choice_menu_add(GTK_CHOICE(choice), "Duplicate name");
	gtk_choice_menu_add(GTK_CHOICE(choice), "Fifth object");
	gtk_choice_menu_add(GTK_CHOICE(choice), "This is a very very very very extremely massive massive name");
	gtk_box_pack_start(GTK_BOX(hbox), choice, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 5);
	gtk_box_pack_start(GTK_BOX(vbox), gtk_hseparator_new(),
						FALSE, FALSE, 5);

	hbox = gtk_hbox_new(FALSE, 0);
	w = gtk_radio_button_new_with_label((GSList *)0, "Sensitive");
	gtk_signal_connect(GTK_OBJECT(w), "toggled",
				GTK_SIGNAL_FUNC(cb_sensitive), choice);
	gtk_box_pack_start(GTK_BOX(hbox), w, FALSE, FALSE, 0);
	rg = gtk_radio_button_group(GTK_RADIO_BUTTON(w));
	w = gtk_radio_button_new_with_label(rg, "Insensitive");
	gtk_signal_connect(GTK_OBJECT(w), "toggled",
				GTK_SIGNAL_FUNC(cb_insensitive), choice);
	gtk_box_pack_start(GTK_BOX(hbox), w, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);

	hbox = gtk_hbox_new(FALSE, 0);
	w = gtk_button_new_with_label("Unselect");
	gtk_box_pack_start(GTK_BOX(hbox), w, FALSE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(w), "clicked",
				GTK_SIGNAL_FUNC(cb_unselect), choice);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);

	hbox = gtk_hbox_new(FALSE, 5);
	w = gtk_label_new("Menu index:");
	gtk_box_pack_start(GTK_BOX(hbox), w, FALSE, FALSE, 0);
	spinbutton = gtk_spin_button_new(NULL, 0.0, 0);
	adj = gtk_spin_button_get_adjustment(GTK_SPIN_BUTTON(spinbutton));
	adj->upper = 5.0;
	adj->step_increment = 1.0;
	gtk_signal_connect(GTK_OBJECT(adj), "value_changed",
				GTK_SIGNAL_FUNC(cb_spinvalue), choice);

	gtk_box_pack_start(GTK_BOX(hbox), spinbutton, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);

	hbox = gtk_hbox_new(FALSE, 0);
	w = gtk_button_new_with_label("Quit");
	gtk_box_pack_start(GTK_BOX(hbox), w, FALSE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(w), "clicked",
				GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);

	gtk_choice_menu_select(GTK_CHOICE(choice), 0);
	gtk_signal_connect(GTK_OBJECT(choice), "select",
				GTK_SIGNAL_FUNC(cb_select), adj);
	gtk_widget_show_all(top);
	gtk_main();
}

